﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using DevComponents.DotNetBar;

namespace managerCheck
{
    public partial class Form1 : Office2007Form
    {
        DataAccessLayer dal = new DataAccessLayer();
        bool flagEdit = true;
        string code = "";

        public Form1()
        {
            InitializeComponent();
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void btnNew_Click(object sender, EventArgs e)
        {
            flagEdit = true;
            expandablePanel1.Expanded = true;            
        }

        private void expandablePanel1_ExpandedChanged(object sender, DevComponents.DotNetBar.ExpandedChangeEventArgs e)
        {
            if (expandablePanel1.Expanded)
            {
                txtName.Focus();
                if (!flagEdit)
                {
                    expandablePanel1.TitleText = "ویرایش اطلاعات";
                    code = dataGridViewX1.CurrentRow.Cells["code"].Value.ToString();
                    txtAddress.Text = dataGridViewX1.CurrentRow.Cells["address"].Value.ToString();
                    txtBankName.Text = dataGridViewX1.CurrentRow.Cells["bankname"].Value.ToString();
                    txtDaryaft.Text = dataGridViewX1.CurrentRow.Cells["daryaft"].Value.ToString();

                    txtDateEnd.Value = FreeControls.PersianDate.Parse(dataGridViewX1.CurrentRow.Cells["datesar"].Value.ToString());
                    txtDateNow.Value = FreeControls.PersianDate.Parse(dataGridViewX1.CurrentRow.Cells["dateNow"].Value.ToString());

                    txtFamily.Text = dataGridViewX1.CurrentRow.Cells["family"].Value.ToString();
                    txtMablagh.Text = dataGridViewX1.CurrentRow.Cells["mablagh"].Value.ToString();
                    txtMande.Text = dataGridViewX1.CurrentRow.Cells["mande"].Value.ToString();
                    txtName.Text = dataGridViewX1.CurrentRow.Cells["name"].Value.ToString();
                    txtShCheck.Text = dataGridViewX1.CurrentRow.Cells["shcheck"].Value.ToString();
                    txtTell.Text = dataGridViewX1.CurrentRow.Cells["tell"].Value.ToString();
                    txtVaziat.Text = dataGridViewX1.CurrentRow.Cells["vaziat"].Value.ToString();


                }
            }
            else
            {
                expandablePanel1.TitleText = "تعریف چک جدید";
                flagEdit = true;
                txtAddress.Text = txtBankName.Text = txtFamily.Text = txtMablagh.Text = txtMande.Text = txtName.Text = txtShCheck.Text = txtTell.Text = "";
                Form1_Load(null, null);
                txtSearchName.Focus();
            }
        }

        private void dataGridViewX1_ColumnAdded(object sender, DataGridViewColumnEventArgs e)
        {
            switch (e.Column.HeaderText)
            {
                case "code":
                    e.Column.HeaderText = "کد";
                    break;
                case "name":
                    e.Column.HeaderText = "نام";
                    break;
                case "family":
                    e.Column.HeaderText = "نام خانوادگی";
                    break;
                case "bankname":
                    e.Column.HeaderText = "نام بانک";
                    break;
                case "tell":
                    e.Column.HeaderText = "تلفن";
                    break;
                case "address":
                    e.Column.HeaderText = "توضیحات";
                    break;
                case "daryaft":
                    e.Column.HeaderText = "نوع دریافت";
                    break;
                case "mablagh":
                    e.Column.HeaderText = "مبلغ";
                    break;
                case "mande":
                    e.Column.HeaderText = "مانده حساب";
                    break;
                case "dateNow":
                    e.Column.HeaderText = "تاریخ دریافت";
                    break;
                case "datesar":
                    e.Column.HeaderText = "تاریخ سررسید";
                    break;
                case "shcheck":
                    e.Column.HeaderText = "شماره چک";
                    break;
                case "vaziat":
                    e.Column.HeaderText = "وضیعت مشتری";
                    break;
                case "vaziatcheck":
                    e.Column.HeaderText = "وضیعت چک";
                    break;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            dal.Disconnect();
            dal.connect();
            dataGridViewX1.DataSource = dal.select("select * from table1");
            dal.Disconnect();
        }

        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (dataGridViewX1.RowCount == 0)
                return;
            flagEdit = false;
            expandablePanel1.Expanded = true;
            
        }

        private void BtnCancel_Click(object sender, EventArgs e)
        {
            expandablePanel1.Expanded = false;
        }

        private void BtnSabt_Click(object sender, EventArgs e)
        {
            string sql = "";

            string dateEnd = txtDateEnd.Value.Year.ToString() + "/" + (txtDateEnd.Value.Month < 10 ? "0" + txtDateEnd.Value.Month.ToString() : txtDateEnd.Value.Month.ToString()) + "/" + (txtDateEnd.Value.Day < 10 ? "0" + txtDateEnd.Value.Day.ToString() : txtDateEnd.Value.Day.ToString());
            string dateNow = txtDateNow.Value.Year.ToString() + "/" + (txtDateNow.Value.Month < 10 ? "0" + txtDateNow.Value.Month.ToString() : txtDateNow.Value.Month.ToString()) + "/" + (txtDateNow.Value.Day < 10 ? "0" + txtDateNow.Value.Day.ToString() : txtDateNow.Value.Day.ToString());

            if (flagEdit)
                sql = " INSERT INTO table1 (name, family, tell, address, daryaft, mablagh, mande, dateNow, datesar, shcheck, bankname, vaziat)"+
                      " VALUES (N'"+txtName.Text+"', N'"+txtFamily.Text+"', N'"+txtTell.Text+"', N'"+txtAddress.Text+"', N'"+txtDaryaft.Text+"', N'"+
                      txtMablagh.Text+"', N'"+txtMande.Text+"', N'"+dateNow+"', N'"+dateEnd+"', N'"+txtShCheck.Text+"', N'"+txtBankName.Text+"', N'"+txtVaziat.Text+"')";
            else
                sql = "UPDATE table1 SET name = N'"+txtName.Text+"', family = N'"+txtFamily.Text+"', tell = N'"+txtTell.Text+"', address = N'"+txtAddress.Text+"', daryaft = N'"+txtDaryaft.Text+
                    "', mablagh = N'"+txtMablagh.Text+"', mande = N'"+txtMande.Text+"', dateNow = N'"+dateNow+"', datesar = N'"+dateEnd+"', shcheck = N'"+txtShCheck.Text+"',bankname = N'"+txtBankName.Text+"', vaziat = N'"+txtVaziat.Text+"' WHERE (code = "+code+")";

            dal.Disconnect();
            dal.connect();
            dal.docommand(sql);
            dal.Disconnect();

            expandablePanel1.Expanded = false;
        }

        private void txtName_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (char.IsNumber(e.KeyChar))
                e.Handled = true;
        }

        private void txtDaryaft_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = true;
        }

        private void txtTell_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (char.IsLetter(e.KeyChar))
                e.Handled = true;
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (dataGridViewX1.RowCount == 0)
                return;
            if (FMessegeBox.FarsiMessegeBox.Show("آیا برای حذف مطمئن هستید؟", "اخطار", FMessegeBox.FMessegeBoxButtons.YesNo) != DialogResult.Yes)
                return;
            dal.Disconnect();
            dal.connect();
            dal.docommand("DELETE FROM table1 WHERE (code = " + dataGridViewX1.CurrentRow.Cells[0].Value.ToString() + ")");
            dal.Disconnect();
            Form1_Load(null, null);
        }

        private void dataGridViewX1_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            btnEdit_Click(null, null);
        }

        private void dataGridViewX1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
            {
                btnEdit_Click(null, null);
            }
        }

        private void txtName_KeyDown(object sender, KeyEventArgs e)
        {
            if(e.KeyValue==13)
                txtFamily.Focus();
            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtDaryaft_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (txtDaryaft.SelectedIndex == 1)
            {
                txtDateEnd.Enabled = txtShCheck.Enabled = txtBankName.Enabled = txtvaziatcheck.Enabled = true;
            }
            else
            {
                txtDateEnd.Enabled = txtShCheck.Enabled = txtBankName.Enabled = txtvaziatcheck.Enabled = false;
            }
        }

        private void txtFamily_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtTell.Focus();
            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtTell_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtAddress.Focus();
            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtAddress_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtDaryaft.Focus();
            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtDaryaft_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtMablagh.Focus();
            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtMablagh_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtMande.Focus();
            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtMande_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtDateNow.Focus();
            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtDateNow_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                if (txtDaryaft.Text == "غیرنقدی")
                    txtDateEnd.Focus();
                else
                    txtVaziat.Focus();

            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtDateEnd_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtShCheck.Focus();
            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtShCheck_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtBankName.Focus();
            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtBankName_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtvaziatcheck.Focus();
            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtvaziatcheck_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtVaziat.Focus();
            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtVaziat_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                BtnSabt.Focus();
            if (e.KeyValue == 27)
                BtnCancel_Click(null, null);
        }

        private void txtMablagh_Leave(object sender, EventArgs e)
        {
            txtMablagh.Text = Money_Text(txtMablagh.Text);
        }

        string Money_Text(string str)
        {
            string rev = Reverse(str);
            string res = "";
            int f = 0;
            for (int i = 0; i < rev.Length; i++)
            {
                f++;
                res += rev[i].ToString();
                if (f == 3)
                {
                    res += ",";
                    f = 0;
                }
            }
            return Reverse(res);
        }

        string Reverse(string str)
        {
            string res = "";
            for (int i = str.Length - 1; i >= 0; i--)
            {
                res += str[i].ToString();
            }
            return res;
        }

        private void txtMablagh_TextChanged(object sender, EventArgs e)
        {

        }

        private void txtMande_Leave(object sender, EventArgs e)
        {
            txtMande.Text = Money_Text(txtMande.Text);

        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Application.Exit();
        }

        private void txtSearchName_TextChanged(object sender, EventArgs e)
        {
            string sqlFilter = "SELECT * FROM table1 WHERE (shcheck LIKE N'" + txtSearchNumber.Text + "%') AND (name LIKE N'" + txtSearchName.Text + "%') AND (family LIKE N'" + txtSearchFamily.Text + "%')";
            dal.connect();
            dataGridViewX1.DataSource = dal.select(sqlFilter);
            dal.Disconnect();
        }

        private void txtSearchName_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtSearchFamily.Focus();
            if (e.KeyValue == 27)
                dataGridViewX1.Focus();
        }

        private void txtSearchFamily_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtSearchNumber.Focus();
            if (e.KeyValue == 27)
                dataGridViewX1.Focus();
        }

        private void txtSearchNumber_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
                txtSearchName.Focus();
            if (e.KeyValue == 27)
                dataGridViewX1.Focus();
        }
    }
}
